﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    internal class BoatCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xBoat = x as DrawningObjectBoat;
            var yBoat = y as DrawningObjectBoat;
            if (xBoat == null && yBoat == null)
            {
                return 0;
            }
            if (xBoat == null && yBoat != null)
            {
                return 1;
            }
            if (xBoat != null && yBoat == null)
            {
                return -1;
            }
            var colorCompare = xBoat.GetBoat.Boat.BodyColor.Name.CompareTo(yBoat.GetBoat.Boat.BodyColor.Name);
            if (colorCompare != 0)
            {
                return colorCompare;
            }
            var speedCompare = xBoat.GetBoat.Boat.Speed.CompareTo(yBoat.GetBoat.Boat.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xBoat.GetBoat.Boat.Weight.CompareTo(yBoat.GetBoat.Boat.Weight);
        }
    }
}
